<?php



require('../HTML_PDF/fpdf.php');




    var $B=0;
    var $I=0;
    var $U=0;
    var $HREF='';
    var $ALIGN='';

    function WriteHTML($html)
    {
        //HTML parser
        $html=str_replace("\n", ' ', $html);
        $a=preg_split('/<(.*)>/U', $html, -1, PREG_SPLIT_DELIM_CAPTURE);
        foreach($a as $i=>$e)
        {
            if($i%2==0)
            {
                //Text
                if($this->HREF)
                    $this->PutLink($this->HREF, $e);
                elseif($this->ALIGN == 'center')
                    $this->Cell(0, 5, $e, 0, 1, 'C');
                else
                    $this->Write(5, $e);
            }
            else
            {
                //Tag
                if($e{0}=='/')
                    $this->CloseTag(strtoupper(substr($e, 1)));
                else
                {
                    //Extract properties
                    $a2=split(' ', $e);
                    $tag=strtoupper(array_shift($a2));
                    $prop=array();
                    foreach($a2 as $v)
                        if(ereg('^([^=]*)=["\']?([^"\']*)["\']?$', $v, $a3))
                            $prop[strtoupper($a3[1])]=$a3[2];
                    $this->OpenTag($tag, $prop);
                }
            }
        }
    }

    function OpenTag($tag, $prop)
    {
        //Opening tag
        if($tag=='B' or $tag=='I' or $tag=='U')
            $this->SetStyle($tag, true);
        if($tag=='A')
            $this->HREF=$prop['HREF'];
        if($tag=='BR')
            $this->Ln(5);
        if($tag=='P')
            $this->ALIGN=$prop['ALIGN'];
        if($tag=='HR')
        {
            if( $prop['WIDTH'] != '' )
                $Width = $prop['WIDTH'];
            else
                $Width = $this->w - $this->lMargin-$this->rMargin;
            $this->Ln(2);
            $x = $this->GetX();
            $y = $this->GetY();
            $this->SetLineWidth(0.4);
            $this->Line($x, $y, $x+$Width, $y);
            $this->SetLineWidth(0.2);
            $this->Ln(2);
        }
    }

    function CloseTag($tag)
    {
        //Closing tag
        if($tag=='B' or $tag=='I' or $tag=='U')
            $this->SetStyle($tag, false);
        if($tag=='A')
            $this->HREF='';
        if($tag=='P')
            $this->ALIGN='';
    }

    function SetStyle($tag, $enable)
    {
        //Modify style and select corresponding font
        $this->$tag+=($enable ? 1 : -1);
        $style='';
        foreach(array('B', 'I', 'U') as $s)
            if($this->$s>0)
                $style.=$s;
        $this->SetFont('', $style);
    }

    function PutLink($URL, $txt)
    {
        //Put a hyperlink
        $this->SetTextColor(0, 0, 255);
        $this->SetStyle('U', true);
        $this->Write(5, $txt, $URL);
        $this->SetStyle('U', false);
        $this->SetTextColor(0);
    }



class InvoicePDF extends FPDF {

	private $PG_W = 190;

	public function __construct($passInYourDataHere = NULL) {
		parent::__construct();		
		$this->LineItems();		
	}
	
		
	public function LineItems() {


$header = array("Description", "Qty.", "Rate", "Sub.", "VAT", "Total");

		// Data
		
		$textWrap = str_repeat("this is a word wrap test ", 3);
		$textNoWrap = "there will be no wrapping here thank you";
		
		$data = array();
				
		$data[] = array($textWrap, 1, 50, 50, 0, 50);
		$data[] = array($textNoWrap, 1, 10500, 10500, 0, 10500);
				
		/* Layout */
		
		$this->SetDataFont();
		$this->AddPage('L');

		// Headers and widths
		
		$w = array(85, 25, 20, 20, 20, 20);

		for($i = 0; $i < count($header); $i++) {
			$this->Cell($w[$i], 7, $header[$i], 1, 0, 'C');
		}

		$this->Ln();

		// Mark start coords

		$x = $this->GetX();
		$y = $this->GetY();
		$i = 0;
		
		foreach($data as $row)
		{	
			$y1 = $this->GetY();
			$this->MultiCell($w[0], 6, $row[0], 'LRB');	
			$y2 = $this->GetY();
			$yH = $y2 - $y1;
						
			$this->SetXY($x + $w[0], $this->GetY() - $yH);
			
			$this->Cell($w[1], $yH, $row[1], 'LRB');
			$this->Cell($w[2], $yH, number_format($row[2], 2), 'LRB', 0, 'R');
			$this->Cell($w[3], $yH, number_format($row[3], 2), 'LRB', 0, 'R');
			$this->Cell($w[4], $yH, number_format($row[4], 2), 'LRB', 0, 'R');
			$this->Cell($w[5], $yH, number_format($row[5], 2), 'LRB', 0, 'R');
						
			$this->Ln();
			
			$i++;
		}
		
		$this->Ln(10);

		$this->setTextFont();
		$this->Cell($w[0] + $w[1] + $w[3], 6, 'Total', 'TB', 0, 'L');
		$this->setDataFont(true);
		$this->Cell($w[2], 6, number_format(2, 2), 'TB', 0, 'R');
		$this->Cell($w[2], 6, number_format(2, 2), 'TB', 0, 'R');
		$this->Cell($w[2], 6, number_format(2, 2), 'TB', 0, 'R');
		$this->Ln();
		
	}

	public function Footer() {

		// Footer
		
		$address = "Roxxor Ltd. Somewhere in London UK";
		
		$this->SetY(-(($this->getAddressLength($address) * 5) + 20));

		$this->SetFont('Arial', '', 7);
		
		$this->Ln();
		$this->writeAddress($address);
	}

	private function setTextFont($isBold = false) {
		$this->SetFont('Arial', $isBold ? 'B' : '', 9);
	}
	
	private function setDataFont($isBold = false) {
		$this->SetFont('Courier', $isBold ? 'B' : '', 8);
	}

	private function getAddressLength($address) {
		return count(explode("\n", $address));
	}
		
	private function writeAddress($address) {
		$lines = explode("\n", $address);
		foreach ($lines as $line) {
			$this->Cell($this->PG_W, 5, $line, 0, 0, 'C');
			$this->Ln(4);
		}
	}	
}






$pdf = new InvoicePDF();


$pdf->WriteHTML('You can<BR><P ALIGN="center">center a line</P>and add a horizontal rule:<BR><HR>');



$pdf->Output();
?>