<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- vim:sw=4:ts=4:et: 
-->
<html>
  <head>

    <title>calendar with week numbers</title>
<style type="text/css">
<!--
input.in {  background-color:#ddff33; }
input.flat { border-style:none; }
table.mcal {  border-style:solid; border-width:1px;background-color:#fff;
          color:#000;border-color:#111;}
td.mcal {  border-style:solid; border-width:1px;background-color:#fff;
          color:#000;border-color:#ddd;}
p.copy { margin-top: 8pt; 
        border-top: 1px solid #bbb;
        font-family: arial,Helvetica,sans-serif;
        font-weight: normal;
        width: 90%;
        font-size: 80%;
        color: #888;
}
-->
</style>
<script type="text/javascript" language="JavaScript">
<!--  to hide script contents from old browsers
// author: Guido Socher except for getWeekNumber.

//--------------------------
/**
 * Author of getWeekNumber function: Thomas Rabaix
 *
 * Small corrections by Guido Socher
 *
 * return the Week Number of a gregorian date using the ISO 8601 format
 * Algorithm from http://personal.ecu.edu/mccartyr/ISOwdALG.txt , Rick McCarty
 *
 * ISO 8601 specifies that Week 01 of the year is the week containing
 * the first Thursday; Monday is Weekday 1, Sunday is Weekday 7;
 */
var isoHelper = {
    getWeekNumber: function(ddate) {
        // 1. Convert input to Y M D
        var Y = ddate.getFullYear();
       
        // 4. Find the DayOfYearNumber for Y M D
        var DayOfYearNumber = isoHelper.findDayOfYearNumber(ddate);
       
        // 5. Find the Jan1Weekday for Y (Monday=1, Sunday=7)
        var Jan1Weekday = isoHelper.findJan1Weekday(ddate);
       
        // 6. Find the Weekday for Y M D
        var WeekDay = isoHelper.findDayWeek(ddate);

        // 7. Find if Y M D falls in YearNumber Y-1, WeekNumber 52 or 53
        var YearNumber = Y;
        var WeekNumber = 0;
        if((DayOfYearNumber <= (8 - Jan1Weekday)) && (Jan1Weekday > 4)) {
            YearNumber = Y - 1;
            ddate.setFullYear(YearNumber); // set the correct year for the isLeapYear
            if((Jan1Weekday == 5) || (Jan1Weekday == 6 && isoHelper.isLeapYear(ddate))) {
                WeekNumber = 53;
            } else {
                WeekNumber = 52;
            }
            ddate.setFullYear(Y); // undo the chage in the date object
        }

        // 8. Find if Y M D falls in YearNumber Y+1, WeekNumber 1
        if(YearNumber == Y) {
            var I;
            if(isoHelper.isLeapYear(ddate)) {
                I = 366;
            } else {
                I = 365
            }
           
            if ((I - DayOfYearNumber) < (4 - WeekDay)) {
                YearNumber = Y + 1;
                WeekNumber = 1;
            }
        }
       
        // 9. Find if Y M D falls in YearNumber Y, WeekNumber 1 through 53
        if(YearNumber == Y) {
            var J;
            J = DayOfYearNumber + (7 - WeekDay) + (Jan1Weekday - 1)
            WeekNumber = J / 7;
            if(Jan1Weekday > 4 ) {
                WeekNumber -= 1;
            }
        }

        return WeekNumber;
    },
    isLeapYear: function(ddate) {
        var Y = ddate.getFullYear();
        if ((Y % 4) == 0 && (Y % 100) != 0) {
            return true;
        }
        if((Y % 400) == 0) {
            return true;
        }
        return false;
    },
    findDayOfYearNumber: function(ddate) {
        var months = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];
       
        var day = ddate.getDate() + months[ddate.getMonth()];
        // only for march and onwards in leap years: 
        if(isoHelper.isLeapYear(ddate) && ddate.getMonth() > 1) {
            day++;
        }
       
        return day;
    },
    findJan1Weekday: function(ddate) {
        var d = new Date(ddate.getFullYear(), 0, 1);
        // convert from 0=sun .. 1=mon
        // to 1=mon to 7=sun
        return(isoHelper.findDayWeek(d));
    },
    findDayWeek: function (ddate) {
        var WeekDay = ddate.getDay();
        if(WeekDay == 0) {
            WeekDay = 7;
        }
       
        return WeekDay;
    }
}
// date object has month in range 0..11
function dayspermonth(ddate) {
    var days;
    var dayinmonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30 ,31];
    days=dayinmonth[ddate.getMonth()];
    if(isoHelper.isLeapYear(ddate) && ddate.getMonth() == 1) {
        days++;
    }
    return(days);
}
//--------------------------
// called at load of html page
function init_settings(){
    var f=document.monthcal;
    var dateobj = new Date();
    f.y.value=dateobj.getFullYear();
    f.m.value=dateobj.getMonth() + 1;
    fillmcal(dateobj.getFullYear(),dateobj.getMonth(),f);
}
//--------------------------
function resetform1(cform) {
    cform.y.value="";
    cform.m.value="";
    cform.d.value="";
    cform.wday.value="";
    cform.wnum.value="";
    cform.err.value="";
    cform.str.value="";
}
function today(cform) {
    var dateobj = new Date();
    resetform1(cform);
    cform.y.value=dateobj.getFullYear();
    cform.m.value=dateobj.getMonth() + 1;
    cform.d.value=dateobj.getDate();
}
function day2date(cform) {
    var yyyy;
    var mm;
    var dd;
    var dateobj;
    var wday = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
    // init result:
    cform.wnum.value="";
    cform.wday.value="";
    cform.wnum.value="";
    cform.str.value="";
    cform.y.value.replace(/[^0-9]/g,"");
    cform.m.value.replace(/[^0-9]/g,"");
    cform.d.value.replace(/[^0-9]/g,"");
    yyyy=parseInt(cform.y.value);
    if (isNaN(yyyy) || yyyy < 1 || yyyy > 9999){
        cform.err.value="ERROR: year must be a positive number, 1-9999";
        return(1);
    }
    mm=parseInt(cform.m.value);
    if (isNaN(mm) || mm < 1 || mm > 12){
        cform.err.value="ERROR: month must be a positive number, 1-12";
        return(1);
    }
    // internally month starts at 0:
    mm--;
    dd=parseInt(cform.d.value);
    if (isNaN(dd) || dd < 1 || dd > 31){
        cform.err.value="ERROR: day must be a positive number, 1-31";
        return(1);
    }
    // use the javascript Date object to do the calculation:
    dateobj = new Date(yyyy,mm,dd); 
    cform.str.value="date:"+yyyy+"-"+(mm+1)+"-"+dd + " :";
    cform.wday.value=wday[dateobj.getDay()];
    cform.wnum.value=isoHelper.getWeekNumber(dateobj);
}
//--------------------------
function calsettoday(cform)
{
    var dateobj = new Date();
    cform.y.value=dateobj.getFullYear();
    cform.m.value=dateobj.getMonth() + 1;
    fillmcal(dateobj.getFullYear(),dateobj.getMonth(),cform);
}
function updatecal(cform)
{
    var yyyy;
    var mm;
    // error handling:
    cform.y.value.replace(/[^0-9]/g,"");
    cform.m.value.replace(/[^0-9]/g,"");
    yyyy=parseInt(cform.y.value);
    if (isNaN(yyyy) || yyyy < 1 || yyyy > 9999){
        cform.y.value=Number.NaN;
        return(1);
    }
    mm=parseInt(cform.m.value);
    if (isNaN(mm) || mm < 1 || mm > 12){
        cform.m.value=Number.NaN;
        return(1);
    }
    cform.y.value=yyyy;
    cform.m.value=mm;
    fillmcal(yyyy,mm-1,cform);
}
function monthminus(cform)
{
    var yyyy;
    var mm;
    // error handling:
    cform.y.value.replace(/[^0-9]/g,"");
    cform.m.value.replace(/[^0-9]/g,"");
    yyyy=parseInt(cform.y.value);
    if (isNaN(yyyy) || yyyy < 1 || yyyy > 9999){
        cform.y.value=Number.NaN;
        return(1);
    }
    mm=parseInt(cform.m.value);
    if (isNaN(mm) || mm < 1 || mm > 12){
        cform.m.value=Number.NaN;
        return(1);
    }
    mm--;
    if (mm<1){
        yyyy--;
        mm=12;
    }
    cform.y.value=yyyy;
    cform.m.value=mm;
    fillmcal(yyyy,mm-1,cform);
}
function monthplus(cform)
{
    var yyyy;
    var mm;
    // error handling:
    cform.y.value.replace(/[^0-9]/g,"");
    cform.m.value.replace(/[^0-9]/g,"");
    yyyy=parseInt(cform.y.value);
    if (isNaN(yyyy) || yyyy < 1 || yyyy > 9999){
        cform.y.value=Number.NaN;
        return(1);
    }
    mm=parseInt(cform.m.value);
    if (isNaN(mm) || mm < 1 || mm > 12){
        cform.m.value=Number.NaN;
        return(1);
    }
    mm++;
    if (mm>12){
        yyyy++;
        mm=1;
    }
    cform.y.value=yyyy;
    cform.m.value=mm;
    fillmcal(yyyy,mm-1,cform);
}
// mm=0..11
function fillmcal(yyyy,mm,cform)
{
    var dd=1;
    var wdayIso;
    var wnum;
    var dperm;
    var line;
    var tdelem;
    var printdd=0;
    var row;
    var dateobj = new Date(yyyy,mm,dd); 
    var today = new Date(); 
    var today_y=today.getFullYear();
    var today_m=today.getMonth(); // 0..11
    var today_d=today.getDate();
    var m2str = new Array("January","February","March","April","May","June","July","August","September","October","November","December");
    cform.caltitle.value=m2str[mm]+" "+yyyy;
    wdayIso=dateobj.getDay();
    // convert from sun=0 to mon=0 (iso 8601):
    wnum=isoHelper.getWeekNumber(dateobj);
    wdayIso--;
    if (wdayIso<0){
        wdayIso=6;
    }
    // dbg:
    //alert("wdayIso:"+wdayIso+" wnum:"+wnum+" "+yyyy+"-"+mm+"-"+dd);
    //return;
    dperm=dayspermonth(dateobj);
    line=0;
    while(line<6){
        line++;
        row=0;
        while(row<9){
            if (row==0){
                tdelem=document.getElementById("mcalr"+line).childNodes[row];
                if (printdd<2){
                    dateobj.setDate(dd);
                    wnum=isoHelper.getWeekNumber(dateobj);
                    // put week number
                    tdelem.firstChild.nodeValue = wnum;
                    tdelem.style.color="#000000"
                }else{
                    // no more dates in this row
                    tdelem.firstChild.nodeValue = ".";
                    tdelem.style.color="#eeeeee"
                }
                row++;
                continue;
            }
            // the empty row:
            if (row==1){
                row++;
                continue;
            }
            if (printdd==0 && row-2 == wdayIso){
                // start of printing
                printdd=1;
            }
            tdelem=document.getElementById("mcalr"+line).childNodes[row];
            tdelem.style.backgroundColor="#ffffff"
            if (printdd == 1){
                tdelem.firstChild.nodeValue = dd;
                tdelem.style.color="#000000";
                if (yyyy==today_y && mm ==today_m && dd==today_d){
                    tdelem.style.backgroundColor="#70ff00"
                }
                dd++;
            }else{
                tdelem.firstChild.nodeValue = ".";
                tdelem.style.color="#eeeeee";
            }
            if (dd>dperm){
                // end of printing days for this month
                printdd=2;
            }
            row++;
        }
    }
}
//--------------------------
//--------------------------

// end hiding contents from old browsers  -->
</script>
  </head>

  <body onload="javascript:init_settings()">

    <h1>calendar with week numbers</h1>

    <table border="0" hspace="10" cellpadding="5">
      <tr>
        <td>
          <form name="monthcal">
            <table border="0" hspace="10">
              <tr>
                <td class="mcal">

                  <center>
                    <h3>Calendar</h3>
                    <input value=" &lt; " onclick="monthminus(this.form)" type="button"> 
                    <input name="y" size="4" type="text" value="" class="in"> - 
                    <input name="m" size="2" type="text" value="" class="in"> 
                    <input value=" &gt; " onclick="monthplus(this.form)" type= "button"><br>
                    <input value=" update " onclick="updatecal(this.form)" type="button"> 
                    <input value=" today " onclick= "calsettoday(this.form)" type="button"><br>
                    <br>
                  </center>

                </td>
              </tr>

              <tr>
                <td>
                  <table class="mcal" cellspacing="0" cellpadding="2">
                    <tr>
                      <td colspan="9"><input name="caltitle" size=
                      "15" type="text" value="" class="flat"
                      readonly><br>
                      </td>

                    </tr>

                    <tr>
                      <th>WK</th> <th>&nbsp;</th> <th>Mo</th> <th>Tu</th> <th>We</th> <th>Th</th> <th>Fr</th> <th>Sa</th> <th>Su</th>

                    </tr>

    <!-- do not reformat this part, spaces matter in the object model, there should be no extra white space -->
                    <tr id="mcalr1"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>
                    <tr id="mcalr2"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>
                    <tr id="mcalr3"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>
                    <tr id="mcalr4"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>
                    <tr id="mcalr5"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>
                    <tr id="mcalr6"><td>&nbsp;</td><td>&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td><td class="mcal">&nbsp;</td></tr>

                    <tr>
                      <td colspan="9"><small><br>
                      Week numbers according to
                      iso8601</small></td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>

          </form>
        </td>

        <td valign="top">print notes:<br>
        <textarea cols="25" rows="6" name="printnotes"></textarea>
        </td>
      </tr>
    </table>

     
<br>
<br>
<br>
<br>
<small>The notes are only temporary but can you print this page together with the notes.</small>
<br>
    <h3>Calculate day and week number for a given date</h3>

    <form>
      yyyy-mm-dd: <input name="y" size="4" type="text" value="" class="in"> - 
      <input name="m" size="2" type="text" value="" class="in"> - 
      <input name="d" size="2" type="text" value="" class="in"> 
      <input value=" today " onclick="today(this.form)" type="button"> 
      <input value=" calculate " onclick= "day2date(this.form)" type="button"> 
      <input value=" reset " onclick="resetform1(this.form)" type="button"><br>

      <input name="err" size="50" type="text" class="flat" readonly><br>
      result:<br>
      <input name="str" size="20" type="text" class="flat" readonly><br>
      day of week: <input name="wday" size="6" type="text" readonly><br>
      iso8601 week number: <input name="wnum" size="2" type="text" readonly>
    </form>

    <h3>Background about ISO 8601</h3>

    ISO 8601 defines the Week as always starting with Monday. The
    first week is the week which contains the first Thursday of the
    calendar year. This implies that it is the week which is mostly
    within the Calendar year and the week containing January 4th.
    <br>
    <p class="copy">
This page is operting system independent. It only requires a
javascript capable webbrowser. You can install it locally on
your PC just by saving this html page.
<br>
<br>
&copy; Guido Socher, License: GPL, 
guidosocher at gmail.com, 
Version: 2009-11-13</p>
  </body>
</html>
